package cn.ibizlab.businesscentral.core.odoo_account.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_account.domain.Account_payment;
import cn.ibizlab.businesscentral.core.odoo_account.filter.Account_paymentSearchContext;
import cn.ibizlab.businesscentral.core.odoo_account.service.IAccount_paymentService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_account.client.account_paymentFeignClient;

/**
 * 实体[付款] 服务对象接口实现
 */
@Slf4j
@Service
public class Account_paymentServiceImpl implements IAccount_paymentService {

    @Autowired
    account_paymentFeignClient account_paymentFeignClient;


    @Override
    public boolean create(Account_payment et) {
        Account_payment rt = account_paymentFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Account_payment> list){
        account_paymentFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Account_payment et) {
        Account_payment rt = account_paymentFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Account_payment> list){
        account_paymentFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=account_paymentFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        account_paymentFeignClient.removeBatch(idList);
    }

    @Override
    public Account_payment get(Long id) {
		Account_payment et=account_paymentFeignClient.get(id);
        if(et==null){
            et=new Account_payment();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Account_payment> searchDefault(Account_paymentSearchContext context) {
        Page<Account_payment> account_payments=account_paymentFeignClient.search(context);
        return account_payments;
    }



}



