package cn.ibizlab.businesscentral.core.odoo_account.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_account.domain.Account_reconcile_model;
import cn.ibizlab.businesscentral.core.odoo_account.filter.Account_reconcile_modelSearchContext;
import cn.ibizlab.businesscentral.core.odoo_account.service.IAccount_reconcile_modelService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_account.client.account_reconcile_modelFeignClient;

/**
 * 实体[请在发票和付款匹配期间创建日记账分录] 服务对象接口实现
 */
@Slf4j
@Service
public class Account_reconcile_modelServiceImpl implements IAccount_reconcile_modelService {

    @Autowired
    account_reconcile_modelFeignClient account_reconcile_modelFeignClient;


    @Override
    public boolean create(Account_reconcile_model et) {
        Account_reconcile_model rt = account_reconcile_modelFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Account_reconcile_model> list){
        account_reconcile_modelFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Account_reconcile_model et) {
        Account_reconcile_model rt = account_reconcile_modelFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Account_reconcile_model> list){
        account_reconcile_modelFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=account_reconcile_modelFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        account_reconcile_modelFeignClient.removeBatch(idList);
    }

    @Override
    public Account_reconcile_model get(Long id) {
		Account_reconcile_model et=account_reconcile_modelFeignClient.get(id);
        if(et==null){
            et=new Account_reconcile_model();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Account_reconcile_model> searchDefault(Account_reconcile_modelSearchContext context) {
        Page<Account_reconcile_model> account_reconcile_models=account_reconcile_modelFeignClient.search(context);
        return account_reconcile_models;
    }



}



