package cn.ibizlab.businesscentral.core.odoo_base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_base.domain.Base_language_install;
import cn.ibizlab.businesscentral.core.odoo_base.filter.Base_language_installSearchContext;
import cn.ibizlab.businesscentral.core.odoo_base.service.IBase_language_installService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_base.client.base_language_installFeignClient;

/**
 * 实体[安装语言] 服务对象接口实现
 */
@Slf4j
@Service
public class Base_language_installServiceImpl implements IBase_language_installService {

    @Autowired
    base_language_installFeignClient base_language_installFeignClient;


    @Override
    public boolean create(Base_language_install et) {
        Base_language_install rt = base_language_installFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Base_language_install> list){
        base_language_installFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Base_language_install et) {
        Base_language_install rt = base_language_installFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Base_language_install> list){
        base_language_installFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=base_language_installFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        base_language_installFeignClient.removeBatch(idList);
    }

    @Override
    public Base_language_install get(Long id) {
		Base_language_install et=base_language_installFeignClient.get(id);
        if(et==null){
            et=new Base_language_install();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Base_language_install> searchDefault(Base_language_installSearchContext context) {
        Page<Base_language_install> base_language_installs=base_language_installFeignClient.search(context);
        return base_language_installs;
    }



}



