package cn.ibizlab.businesscentral.core.odoo_base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_base.domain.Res_groups;
import cn.ibizlab.businesscentral.core.odoo_base.filter.Res_groupsSearchContext;
import cn.ibizlab.businesscentral.core.odoo_base.service.IRes_groupsService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_base.client.res_groupsFeignClient;

/**
 * 实体[访问群] 服务对象接口实现
 */
@Slf4j
@Service
public class Res_groupsServiceImpl implements IRes_groupsService {

    @Autowired
    res_groupsFeignClient res_groupsFeignClient;


    @Override
    public boolean create(Res_groups et) {
        Res_groups rt = res_groupsFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Res_groups> list){
        res_groupsFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Res_groups et) {
        Res_groups rt = res_groupsFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Res_groups> list){
        res_groupsFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=res_groupsFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        res_groupsFeignClient.removeBatch(idList);
    }

    @Override
    public Res_groups get(Long id) {
		Res_groups et=res_groupsFeignClient.get(id);
        if(et==null){
            et=new Res_groups();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Res_groups> searchDefault(Res_groupsSearchContext context) {
        Page<Res_groups> res_groupss=res_groupsFeignClient.search(context);
        return res_groupss;
    }



}



