package cn.ibizlab.businesscentral.core.odoo_base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_base.domain.Res_partner;
import cn.ibizlab.businesscentral.core.odoo_base.filter.Res_partnerSearchContext;
import cn.ibizlab.businesscentral.core.odoo_base.service.IRes_partnerService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_base.client.res_partnerFeignClient;

/**
 * 实体[联系人] 服务对象接口实现
 */
@Slf4j
@Service
public class Res_partnerServiceImpl implements IRes_partnerService {

    @Autowired
    res_partnerFeignClient res_partnerFeignClient;


    @Override
    public boolean create(Res_partner et) {
        Res_partner rt = res_partnerFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Res_partner> list){
        res_partnerFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Res_partner et) {
        Res_partner rt = res_partnerFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Res_partner> list){
        res_partnerFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=res_partnerFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        res_partnerFeignClient.removeBatch(idList);
    }

    @Override
    public Res_partner get(Long id) {
		Res_partner et=res_partnerFeignClient.get(id);
        if(et==null){
            et=new Res_partner();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Res_partner> searchDefault(Res_partnerSearchContext context) {
        Page<Res_partner> res_partners=res_partnerFeignClient.search(context);
        return res_partners;
    }



}



