package cn.ibizlab.businesscentral.core.odoo_base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_base.domain.Res_partner_industry;
import cn.ibizlab.businesscentral.core.odoo_base.filter.Res_partner_industrySearchContext;
import cn.ibizlab.businesscentral.core.odoo_base.service.IRes_partner_industryService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_base.client.res_partner_industryFeignClient;

/**
 * 实体[工业] 服务对象接口实现
 */
@Slf4j
@Service
public class Res_partner_industryServiceImpl implements IRes_partner_industryService {

    @Autowired
    res_partner_industryFeignClient res_partner_industryFeignClient;


    @Override
    public boolean create(Res_partner_industry et) {
        Res_partner_industry rt = res_partner_industryFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Res_partner_industry> list){
        res_partner_industryFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Res_partner_industry et) {
        Res_partner_industry rt = res_partner_industryFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Res_partner_industry> list){
        res_partner_industryFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=res_partner_industryFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        res_partner_industryFeignClient.removeBatch(idList);
    }

    @Override
    public Res_partner_industry get(Long id) {
		Res_partner_industry et=res_partner_industryFeignClient.get(id);
        if(et==null){
            et=new Res_partner_industry();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Res_partner_industry> searchDefault(Res_partner_industrySearchContext context) {
        Page<Res_partner_industry> res_partner_industrys=res_partner_industryFeignClient.search(context);
        return res_partner_industrys;
    }



}



