package cn.ibizlab.businesscentral.core.odoo_calendar.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.odoo_calendar.domain.Calendar_event;
import cn.ibizlab.businesscentral.core.odoo_calendar.filter.Calendar_eventSearchContext;


/**
 * 实体[Calendar_event] 服务对象接口
 */
public interface ICalendar_eventService{

    boolean create(Calendar_event et) ;
    void createBatch(List<Calendar_event> list) ;
    boolean update(Calendar_event et) ;
    void updateBatch(List<Calendar_event> list) ;
    boolean remove(Long key) ;
    void removeBatch(Collection<Long> idList) ;
    Calendar_event get(Long key) ;
    Page<Calendar_event> searchDefault(Calendar_eventSearchContext context) ;

}



