package cn.ibizlab.businesscentral.core.odoo_event.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_event.domain.Event_type;
import cn.ibizlab.businesscentral.core.odoo_event.filter.Event_typeSearchContext;
import cn.ibizlab.businesscentral.core.odoo_event.service.IEvent_typeService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_event.client.event_typeFeignClient;

/**
 * 实体[活动类别] 服务对象接口实现
 */
@Slf4j
@Service
public class Event_typeServiceImpl implements IEvent_typeService {

    @Autowired
    event_typeFeignClient event_typeFeignClient;


    @Override
    public boolean create(Event_type et) {
        Event_type rt = event_typeFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Event_type> list){
        event_typeFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Event_type et) {
        Event_type rt = event_typeFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Event_type> list){
        event_typeFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=event_typeFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        event_typeFeignClient.removeBatch(idList);
    }

    @Override
    public Event_type get(Long id) {
		Event_type et=event_typeFeignClient.get(id);
        if(et==null){
            et=new Event_type();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Event_type> searchDefault(Event_typeSearchContext context) {
        Page<Event_type> event_types=event_typeFeignClient.search(context);
        return event_types;
    }



}



