package cn.ibizlab.businesscentral.core.odoo_mrp.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_mrp.domain.Mrp_production;
import cn.ibizlab.businesscentral.core.odoo_mrp.filter.Mrp_productionSearchContext;
import cn.ibizlab.businesscentral.core.odoo_mrp.service.IMrp_productionService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_mrp.client.mrp_productionFeignClient;

/**
 * 实体[Production Order] 服务对象接口实现
 */
@Slf4j
@Service
public class Mrp_productionServiceImpl implements IMrp_productionService {

    @Autowired
    mrp_productionFeignClient mrp_productionFeignClient;


    @Override
    public boolean create(Mrp_production et) {
        Mrp_production rt = mrp_productionFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Mrp_production> list){
        mrp_productionFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Mrp_production et) {
        Mrp_production rt = mrp_productionFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Mrp_production> list){
        mrp_productionFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=mrp_productionFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        mrp_productionFeignClient.removeBatch(idList);
    }

    @Override
    public Mrp_production get(Long id) {
		Mrp_production et=mrp_productionFeignClient.get(id);
        if(et==null){
            et=new Mrp_production();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Mrp_production> searchDefault(Mrp_productionSearchContext context) {
        Page<Mrp_production> mrp_productions=mrp_productionFeignClient.search(context);
        return mrp_productions;
    }



}



