package cn.ibizlab.businesscentral.core.odoo_portal.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_portal.domain.Portal_wizard_user;
import cn.ibizlab.businesscentral.core.odoo_portal.filter.Portal_wizard_userSearchContext;
import cn.ibizlab.businesscentral.core.odoo_portal.service.IPortal_wizard_userService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_portal.client.portal_wizard_userFeignClient;

/**
 * 实体[门户用户配置] 服务对象接口实现
 */
@Slf4j
@Service
public class Portal_wizard_userServiceImpl implements IPortal_wizard_userService {

    @Autowired
    portal_wizard_userFeignClient portal_wizard_userFeignClient;


    @Override
    public boolean create(Portal_wizard_user et) {
        Portal_wizard_user rt = portal_wizard_userFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Portal_wizard_user> list){
        portal_wizard_userFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Portal_wizard_user et) {
        Portal_wizard_user rt = portal_wizard_userFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Portal_wizard_user> list){
        portal_wizard_userFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=portal_wizard_userFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        portal_wizard_userFeignClient.removeBatch(idList);
    }

    @Override
    public Portal_wizard_user get(Long id) {
		Portal_wizard_user et=portal_wizard_userFeignClient.get(id);
        if(et==null){
            et=new Portal_wizard_user();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Portal_wizard_user> searchDefault(Portal_wizard_userSearchContext context) {
        Page<Portal_wizard_user> portal_wizard_users=portal_wizard_userFeignClient.search(context);
        return portal_wizard_users;
    }



}



