package cn.ibizlab.businesscentral.core.odoo_product.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_product.domain.Product_category;
import cn.ibizlab.businesscentral.core.odoo_product.filter.Product_categorySearchContext;
import cn.ibizlab.businesscentral.core.odoo_product.service.IProduct_categoryService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_product.client.product_categoryFeignClient;

/**
 * 实体[产品种类] 服务对象接口实现
 */
@Slf4j
@Service
public class Product_categoryServiceImpl implements IProduct_categoryService {

    @Autowired
    product_categoryFeignClient product_categoryFeignClient;


    @Override
    public boolean create(Product_category et) {
        Product_category rt = product_categoryFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Product_category> list){
        product_categoryFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Product_category et) {
        Product_category rt = product_categoryFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Product_category> list){
        product_categoryFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=product_categoryFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        product_categoryFeignClient.removeBatch(idList);
    }

    @Override
    public Product_category get(Long id) {
		Product_category et=product_categoryFeignClient.get(id);
        if(et==null){
            et=new Product_category();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Product_category> searchDefault(Product_categorySearchContext context) {
        Page<Product_category> product_categorys=product_categoryFeignClient.search(context);
        return product_categorys;
    }



}



