package cn.ibizlab.businesscentral.core.odoo_rating.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_rating.domain.Rating_mixin;
import cn.ibizlab.businesscentral.core.odoo_rating.filter.Rating_mixinSearchContext;
import cn.ibizlab.businesscentral.core.odoo_rating.service.IRating_mixinService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_rating.client.rating_mixinFeignClient;

/**
 * 实体[混合评级] 服务对象接口实现
 */
@Slf4j
@Service
public class Rating_mixinServiceImpl implements IRating_mixinService {

    @Autowired
    rating_mixinFeignClient rating_mixinFeignClient;


    @Override
    public boolean create(Rating_mixin et) {
        Rating_mixin rt = rating_mixinFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Rating_mixin> list){
        rating_mixinFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Rating_mixin et) {
        Rating_mixin rt = rating_mixinFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Rating_mixin> list){
        rating_mixinFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=rating_mixinFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        rating_mixinFeignClient.removeBatch(idList);
    }

    @Override
    public Rating_mixin get(Long id) {
		Rating_mixin et=rating_mixinFeignClient.get(id);
        if(et==null){
            et=new Rating_mixin();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Rating_mixin> searchDefault(Rating_mixinSearchContext context) {
        Page<Rating_mixin> rating_mixins=rating_mixinFeignClient.search(context);
        return rating_mixins;
    }



}



