package cn.ibizlab.businesscentral.core.odoo_repair.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_repair.domain.Repair_cancel;
import cn.ibizlab.businesscentral.core.odoo_repair.filter.Repair_cancelSearchContext;
import cn.ibizlab.businesscentral.core.odoo_repair.service.IRepair_cancelService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_repair.client.repair_cancelFeignClient;

/**
 * 实体[取消维修] 服务对象接口实现
 */
@Slf4j
@Service
public class Repair_cancelServiceImpl implements IRepair_cancelService {

    @Autowired
    repair_cancelFeignClient repair_cancelFeignClient;


    @Override
    public boolean create(Repair_cancel et) {
        Repair_cancel rt = repair_cancelFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Repair_cancel> list){
        repair_cancelFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Repair_cancel et) {
        Repair_cancel rt = repair_cancelFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Repair_cancel> list){
        repair_cancelFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=repair_cancelFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        repair_cancelFeignClient.removeBatch(idList);
    }

    @Override
    public Repair_cancel get(Long id) {
		Repair_cancel et=repair_cancelFeignClient.get(id);
        if(et==null){
            et=new Repair_cancel();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Repair_cancel> searchDefault(Repair_cancelSearchContext context) {
        Page<Repair_cancel> repair_cancels=repair_cancelFeignClient.search(context);
        return repair_cancels;
    }



}



