package cn.ibizlab.businesscentral.core.odoo_repair.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_repair.domain.Repair_line;
import cn.ibizlab.businesscentral.core.odoo_repair.filter.Repair_lineSearchContext;
import cn.ibizlab.businesscentral.core.odoo_repair.service.IRepair_lineService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_repair.client.repair_lineFeignClient;

/**
 * 实体[修理明细行(零件)] 服务对象接口实现
 */
@Slf4j
@Service
public class Repair_lineServiceImpl implements IRepair_lineService {

    @Autowired
    repair_lineFeignClient repair_lineFeignClient;


    @Override
    public boolean create(Repair_line et) {
        Repair_line rt = repair_lineFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Repair_line> list){
        repair_lineFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Repair_line et) {
        Repair_line rt = repair_lineFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Repair_line> list){
        repair_lineFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=repair_lineFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        repair_lineFeignClient.removeBatch(idList);
    }

    @Override
    public Repair_line get(Long id) {
		Repair_line et=repair_lineFeignClient.get(id);
        if(et==null){
            et=new Repair_line();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Repair_line> searchDefault(Repair_lineSearchContext context) {
        Page<Repair_line> repair_lines=repair_lineFeignClient.search(context);
        return repair_lines;
    }



}



