package cn.ibizlab.businesscentral.core.odoo_resource.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_resource.domain.Resource_calendar;
import cn.ibizlab.businesscentral.core.odoo_resource.filter.Resource_calendarSearchContext;
import cn.ibizlab.businesscentral.core.odoo_resource.service.IResource_calendarService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_resource.client.resource_calendarFeignClient;

/**
 * 实体[资源工作时间] 服务对象接口实现
 */
@Slf4j
@Service
public class Resource_calendarServiceImpl implements IResource_calendarService {

    @Autowired
    resource_calendarFeignClient resource_calendarFeignClient;


    @Override
    public boolean create(Resource_calendar et) {
        Resource_calendar rt = resource_calendarFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Resource_calendar> list){
        resource_calendarFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Resource_calendar et) {
        Resource_calendar rt = resource_calendarFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Resource_calendar> list){
        resource_calendarFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=resource_calendarFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        resource_calendarFeignClient.removeBatch(idList);
    }

    @Override
    public Resource_calendar get(Long id) {
		Resource_calendar et=resource_calendarFeignClient.get(id);
        if(et==null){
            et=new Resource_calendar();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Resource_calendar> searchDefault(Resource_calendarSearchContext context) {
        Page<Resource_calendar> resource_calendars=resource_calendarFeignClient.search(context);
        return resource_calendars;
    }



}



