package cn.ibizlab.businesscentral.core.odoo_resource.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_resource.domain.Resource_calendar_attendance;
import cn.ibizlab.businesscentral.core.odoo_resource.filter.Resource_calendar_attendanceSearchContext;
import cn.ibizlab.businesscentral.core.odoo_resource.service.IResource_calendar_attendanceService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_resource.client.resource_calendar_attendanceFeignClient;

/**
 * 实体[工作细节] 服务对象接口实现
 */
@Slf4j
@Service
public class Resource_calendar_attendanceServiceImpl implements IResource_calendar_attendanceService {

    @Autowired
    resource_calendar_attendanceFeignClient resource_calendar_attendanceFeignClient;


    @Override
    public boolean create(Resource_calendar_attendance et) {
        Resource_calendar_attendance rt = resource_calendar_attendanceFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Resource_calendar_attendance> list){
        resource_calendar_attendanceFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Resource_calendar_attendance et) {
        Resource_calendar_attendance rt = resource_calendar_attendanceFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Resource_calendar_attendance> list){
        resource_calendar_attendanceFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=resource_calendar_attendanceFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        resource_calendar_attendanceFeignClient.removeBatch(idList);
    }

    @Override
    public Resource_calendar_attendance get(Long id) {
		Resource_calendar_attendance et=resource_calendar_attendanceFeignClient.get(id);
        if(et==null){
            et=new Resource_calendar_attendance();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Resource_calendar_attendance> searchDefault(Resource_calendar_attendanceSearchContext context) {
        Page<Resource_calendar_attendance> resource_calendar_attendances=resource_calendar_attendanceFeignClient.search(context);
        return resource_calendar_attendances;
    }



}



